title   67HZCT.ASM
;-----------------------------------------------------------
; F.J.Lortz /c't 1993
; 67HZ fr Standard-VGA im 640*480 Grafikmodus
; mit horizontaler Bildlagekorrektur
;-----------------------------------------------------------
; COM File erzeugen mit:        TASM 67HZCT;
;                               TLINK /t 67HZCT;
;-----------------------------------------------------------
        LOCALS
        .model  TINY
NOMOVE          EQU     0       ; 1 = keine Lagekorrektur
NOCHANGE        EQU     0       ; 1 = Quarz nicht umschalten
; CRTC Register 4 und 5
INDEXREG        EQU     03D4h   ; CRTC-Adreregister
;-----------------------------------------------------------
;Allgemeine Makros
;-----------------------------------------------------------
SetIntVec       MACRO   IntNo, VecOfs
        MOV     AX, 2500H+IntNo
        MOV     DX, OFFSET VecOfs
        INT     21H
ENDM

GetIntVec       MACRO IntNo, Vector
        MOV     AX, 3500H+IntNo
        INT     21H
        MOV     WORD PTR [Vector]  , BX
        MOV     WORD PTR [Vector+2], ES
ENDM

Dos     MACRO   func, param
        ifb <func>
                display "Funktionsnummer fehlt!"
                err
        endif
        ifnb <param>
                mov     ax, func*100h + param
        else
                mov     ah, func
        endif
        int     21h
endm

; IndexOut gibt das Byte Index an den Port in DX aus
; inkrementiert DX und gibt dann das Byte b aus
IndexOut        macro index, b
local   @@1
        mov     al, index
        out     dx, al
;       jmp     @@1     ;  aktivieren, falls VGA zu langsam
@@1:    inc     dx
        mov     al, b
        out     dx,al
endm
;-----------------------------------------------------------
        .CODE
        ASSUME CS:@code
        ORG 100h

start:  jmp     install
        org     103h    ; !!! feste Patch-Adresse !!!
                        ; (default: 2 Zeichen n. rechts)
reg4:   db      52h     ; Patch: CRTC-Register 4
reg5:   db      9Eh     ; Patch: CRTC-Register 5

NewInt10        proc near       ; neuer Int 10h
        cmp     ah,0            ; Moduswechsel (ah == 0) ?
        jnz     sk1             ; nein dann jump
        mov     Word Ptr cs:saveax, ax  ; Mode sichern

sk1:    pushf
;       call    dword ptr cs:save10 ; alten int 10h aufrufen
        db      9Ah             ; call far "hartcodiert"
saveInt10:
        dd      0               ; Patch: alter Int10h Vektor
        push    ax
        push    dx
        mov     ax, Word Ptr cs:saveax  ; Mode testen
        cmp     ax, 12h         ; 640*480 16 Farben
        jz      moveit
        cmp     ax, 25h         ; 640*480 16 Farben
        jz      moveit          ; (nur Tseng)
        cmp     ax, 2Eh         ; 640*480 256 Farben
        jz      moveit          ; (nur Tseng)
        cmp     ax, 03h         ; im Textmodus
        jz      doit            ; 480 Zeilen setzen
        jmp     skip

moveit:         ; *** VGAaus
ife     NOMOVE
        mov     dx, 03C4h       ; Sequencer aus
        IndexOut 0, 1
        mov     dx,INDEXREG     ; CRTC-Reset
        mov     al, 017h
        out     dx, al
        inc     dx
        in      al, dx
        and     al, 07Fh
        out     dx, al
        dec     dx
        mov     al, 011h        ; die CRTC-Register
        out     dx, al          ; 0-7 freigeben
        inc     dx
        in      al, dx
        and     al, 07Fh
        out     dx, al

        dec     dx              ; *** move ***
        IndexOut 4, <byte ptr cs:[REG4]>
                                ; Start Horizontal Retrace
        dec     dx
        IndexOut 5, <byte ptr cs:[REG5]>
                                ; End Horizontal Retrace
        mov     dx, 03DAh       ; reset Flip-Flop
        in      al, dx          ; via dummy read
        mov     dx, 03C0h       ; Attribute Controller ein
        mov     al, 20h
        out     dx, al
                                ; *** VGAein ***
        mov     dx,INDEXREG     ; Sequencer Register sperren
        mov     al, 011h
        out     dx, al
        inc     dx
        in      al, dx
        or      al, 080h
        out     dx, al
        dec     dx
        mov     al, 017h        ; CRTC-Reset freigeben
        out     dx, al
        inc     dx
        in      al, dx
        or      al, 080h
        out     dx, al
        mov     dx, 03C4h       ;Sequencer ein
        IndexOut        0,3
endif

doit:
ife     NOCHANGE
;       Quarz umschalten (-mat c't 1/1992)
        mov     dx, 03CCh       ; misc out reg /read
        in      al, dx
        and     al, 0F3h        ; Clock Bits lschen
        or      al, 0C4h        ; 480 Zeilen (Bits 7,6)
                                ; 28MHz (Bit2)
        mov     dx, 03C2h       ; misc. out reg /write
        out     dx, al
endif

skip1:  mov     word ptr cs:saveax, -1  ; Flag ungltig
skip:   pop     dx
        pop     ax
        iret
NewInt10        endp

saveax: dw      -1              ; Flag: -1 == ungltig
                                ; 0 == aktiver Moduswechsel
install proc    near

;------ transienter Teil -----------------------------------
        cli                     ; Int10 auf NEWINT10 setzen
        GetIntVec 10h, SaveInt10
        SetIntVec 10h, NewInt10
        sti
        mov     ah, 0Fh         ; aktuellen Modus lesen
        int     10h
        mov     ah, 0h          ; Modus neu setzen
        int     10h
        lea     dx, titl        ; Titel ausgeben
        dos     9
        lea     dx, install
        int     27h             ; terminate & stay resident
install endp

titl:   db      "* 67HZCT "
ife     NOMOVE
        db      " + MOVE "
endif
        db      " V 1.2 11.93 F.J.Lortz/-mat/c't ",10,13,"$"
        end     start
        end
