PROGRAM Hmove; {$A-,B-,I+,R-,V-} { Franz J. Lortz/c't 1993 }
{ Aufruf: HMOVE <MoveHor>;  MoveHor zwischen -6 und +6 }
USES Dos,Crt;
CONST
  VMode: INTEGER = $12;                               { VideoModus}
  Reg4Org = $54;                       { Defaultwert Start Retrace}
  EndRetrace = $60;                      { Defaultwert End Retrace}
  BUFSIZE = 5;                              { Filebuffer fr Patch}
VAR
  MoveHor: INTEGER;                       { Verschiebungsparameter}
  LastVideoMode: INTEGER;          { Modus beim Aufruf von MoveHor}
  Reg4, Reg5: BYTE;                         { VGA-Register 4 und 5}
  Oldexit: POINTER;                { Pointer auf alte Exit-Routine}
  Code : INTEGER;  Regs: Registers;  { VAL-Error; Register fr INT}

FUNCTION B2H(h : BYTE) : STRING;             {ByteToHex-Umwandlung}
CONST HXA : ARRAY [0..15] OF CHAR = '0123456789ABCDEF';
BEGIN
  B2H[0] := #2;  B2H[1] := HXA[h SHR 4];  B2H[2] := HXA[h AND $0F];
END;

PROCEDURE VGAAus;
BEGIN { nach Olaf Kummer c't 9/1991}
  INLINE($FA);                               {CLI: Interrupts sperren}
  Port[$3C4] := 0; Port[$3C5] := 1;            {Sequenzer ausschalten}
  Port[$3D4] := $17; Port[$3D5] := Port[$3D5] AND $7F;    {CRTC-Reset}
  Port[$3D4] := $11;
  Port[$3D5] := Port[$3D5] AND $7F;          {CRTC-Regs 0-7 freigeben}
  Port[$3D5] := Port[$3D5] AND $7F;
END;

PROCEDURE VGAEin;
BEGIN {nach Olaf Kummer c't 9/1991}
  Port[$3D4]:=$11;
  Port[$3D5]:=Port[$3D5] OR $80;               {CRTC-Regs 0-7 sperren}
  Port[$3D4]:=$17;
  Port[$3D5]:=Port[$3D5] OR $80;                {CRTC-Reset freigeben}
  Port[$3D5]:=Port[$3D5] OR $80;
  Port[$3C4]:=0; Port[$3C5] := 3;              {Sequenzer einschalten}
  INLINE($FB);                              {STI: Interrupts erlauben}
END;

PROCEDURE VGAMove(Reg4, Reg5 : BYTE); {Bild verschieben via Reg4/Reg5}
VAR Dummy: BYTE;
BEGIN
  Port[$3D4] := 4; {Start Hor. Retrace}    Port[$3D5] := Reg4;
  Port[$3D4] := 5; Port[$3D5] := Reg5;              {End Hor. Retrace}
  Dummy := Port[$3DA];  Port[$3C0] := $20; {Attribute Controller frei}
END;

FUNCTION GetVideoMode : INTEGER;         { aktuellen Videomodus lesen}
BEGIN   Regs.AH:=$0F;  Intr($10, Regs);  GetVideoMode := Regs.AL; END;

PROCEDURE SetVideoMode(Mode : INTEGER);            {Videomodus setzen}
BEGIN   Regs.AX:=Mode;   Intr($10, Regs); END;

{$F+} PROCEDURE MyExit; {$F-}                 {Modus wiederherstellen}
BEGIN   ExitProc := OldExit;  SetVideoMode(LastVideoMode); END;

PROCEDURE Msg(s:STRING);
BEGIN   WriteLn(s); REPEAT UNTIL (readkey = #13); END;

PROCEDURE PATCH;        {ermittelte Bildlage in 67HZCT.COM einpatchen}
var f : file; Buf : array[1..BUFSIZE] of byte;  count, result : word;
begin
   Assign(f, '67HZCT.COM');  Reset(f, 1);
   BlockRead (f, Buf, BUFSIZE, count); Buf[4] := Reg4; Buf[5] := Reg5;
   seek(f,0);  BlockWrite(f, Buf, count, result); Close(f);
end;

BEGIN  {Hmove}
  DirectVideo := FALSE;  OldExit := ExitProc;  ExitProc := @MyExit;
  LastVideoMode := GetVideoMode;               {Originalmodus sichern}
  TextBackground(LightGray); TextColor(Black); ClrScr; {weier Schirm}
  Val (ParamStr(1), MoveHor, Code);
  IF (MoveHor < -6) OR  (MoveHor > 6) THEN  HALT(1);
  Reg4 := Reg4Org + Lo(MoveHor);
  {Bei Reg 5: Der Controller wertet nur die Bits 7 und 0-4 aus}
  Reg5 := ((EndRetrace + Lo(MoveHor)) AND $1f) OR $80;
  Write('HMOVE F.J.Lortz/c''t 1993',^J^M,^J,'MoveHor: ',MoveHor);
  WriteLn('    Reg4: ',B2H(Reg4), 'h    Reg5: ',B2H(Reg5), 'h',^J^M);
  Msg('<ENTER>');           {Parameter anzeigen und weiter nach Enter}
  TextBackground(Black); TextColor(LightGray); SetVideoMode(VMode);
  WITH Regs DO BEGIN                   {ClrScr mit weiem Hintergrund}
     AX:=$600;  CX:=$0; BH:=7; DL:=Mem[$40:$4A]; DH:=Mem[$40:$84];
     Intr($10,Regs);                  {DL/DH: BIOS-Spalten und Zeilen}
  END;
  Msg('*** Im Grafikmodus ***'); VGAAus;  VGAmove(Reg4,Reg5);  VGAEin;
  Msg('*** Verschoben ***');  Patch; HALT(0);
END.
